// Paint1View.cpp : implementation of the CPaint1View class
//

#include "stdafx.h"
#include "Paint1.h"

#include "Paint1Doc.h"
#include "Paint1View.h"
#include ".\paint1view.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CPaint1View

IMPLEMENT_DYNCREATE(CPaint1View, CView)

BEGIN_MESSAGE_MAP(CPaint1View, CView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
    ON_WM_LBUTTONDOWN()
END_MESSAGE_MAP()

// CPaint1View construction/destruction

CPaint1View::CPaint1View()
{
    m_Display = Fonts;
}

CPaint1View::~CPaint1View()
{
}

BOOL CPaint1View::PreCreateWindow(CREATESTRUCT& cs)
{
     cs.cx = 440;
     cs.cy = 480;

     cs.style &= ~WS_SIZEBOX;

	return CView::PreCreateWindow(cs);
}

// CPaint1View drawing

void CPaint1View::OnDraw(CDC* pDC)
{
	CPaint1Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

     switch (m_Display)
     {
          case Fonts:
               ShowFonts(pDC);
               break;
          case Pens:
               ShowPens(pDC);
               break;
          case Brushes:
               ShowBrushes(pDC);
               break;
     }
}


// CPaint1View printing

BOOL CPaint1View::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CPaint1View::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CPaint1View::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}


// CPaint1View diagnostics

#ifdef _DEBUG
void CPaint1View::AssertValid() const
{
	CView::AssertValid();
}

void CPaint1View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CPaint1Doc* CPaint1View::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPaint1Doc)));
	return (CPaint1Doc*)m_pDocument;
}
#endif //_DEBUG


// CPaint1View message handlers

void CPaint1View::ShowFonts(CDC* pDC)
{
    // Initialize a LOGFONT structure for the fonts.
    LOGFONT logFont;
    logFont.lfHeight = 8;
    logFont.lfWidth = 0;
    logFont.lfEscapement = 0;
    logFont.lfOrientation = 0;
    logFont.lfWeight = FW_NORMAL;
    logFont.lfItalic = 0;
    logFont.lfUnderline = 0;
    logFont.lfStrikeOut = 0;
    logFont.lfCharSet = ANSI_CHARSET;
    logFont.lfOutPrecision = OUT_DEFAULT_PRECIS;
    logFont.lfClipPrecision = CLIP_DEFAULT_PRECIS;
    logFont.lfQuality = PROOF_QUALITY;
    logFont.lfPitchAndFamily = VARIABLE_PITCH | FF_ROMAN;
    strcpy(logFont.lfFaceName, "Times New Roman");

// Initialize the position of text in the window.
    int position = 0;
	TEXTMETRIC tm;

    // Create and display eight example fonts.
    for (int x=0; x<4; ++x)
    {
         // Set the new font's height.
         logFont.lfHeight = 16 + (x * 8);

         // Create a new font and select it into the DC.
         CFont font;
         font.CreateFontIndirect(&logFont);
         CFont* oldFont = pDC->SelectObject(&font);

         // Print text with the new font.
         position += logFont.lfHeight;
         pDC->TextOut(20, position, "A sample font.");

		 pDC->GetTextMetrics(&tm);
		 TRACE("%d %d\n", tm.tmInternalLeading, tm.tmExternalLeading);

         // Restore the old font to the DC.
         pDC->SelectObject(oldFont);
    }

	position = 0;
	
	for (int x=0; x<4; ++x)
    {
         // Set the new font's height.
         logFont.lfHeight = - (16 + (x * 8));

         // Create a new font and select it into the DC.
         CFont font;
         font.CreateFontIndirect(&logFont);
         CFont* oldFont = pDC->SelectObject(&font);

         // Print text with the new font.
         position -= logFont.lfHeight;
         pDC->TextOut(50, position, "A sample font.");

		 pDC->GetTextMetrics(&tm);
		 TRACE("%d %d\n", tm.tmInternalLeading, tm.tmExternalLeading);

         // Restore the old font to the DC.
         pDC->SelectObject(oldFont);
    }
}

void CPaint1View::ShowPens(CDC* pDC)
{
     // Initialize the line position.
     int position = 10;

     // Draw sixteen lines in the window.
     for (int x=0; x<16; ++x)
     {
          // Create a new pen and select it into the DC.
          CPen pen(PS_DOT, x*2+1, RGB(0, 0, 255));
          CPen* oldPen = pDC->SelectObject(&pen);

          // Draw a line with the new pen.
          position +=  x * 2 + 10;
          pDC->MoveTo(20, position);
          pDC->LineTo(400, position);

          // Restore the old pen to the DC.
          pDC->SelectObject(oldPen);
     }
}

void CPaint1View::ShowBrushes(CDC* pDC)
{
     // Initialize the rectangle position.
     int position = 0;

     // Select pen to use for rectangle borders
     CPen pen(PS_SOLID, 5, RGB(255, 0, 0));
     CPen* oldPen = pDC->SelectObject(&pen);

     // Draw seven rectangles.
     for (int x=0; x<7; ++x)
     {
          CBrush* brush;

          // Create a solid or hatched brush.
          if (x == 6)
               brush = new CBrush(RGB(0,255,0));
          else
              brush = new CBrush(x, RGB(0,255,0));

          // Select the new brush into the DC.
          CBrush* oldBrush = pDC->SelectObject(brush);

          // Draw the rectangle.
          position += 50;
          pDC->Rectangle(20, position, 400, position + 40);

          // Restore the DC and delete the brush.
          pDC->SelectObject(oldBrush);
          delete brush;
     }

// Restore the old pen to the DC.
     pDC->SelectObject(oldPen);
}

void CPaint1View::OnLButtonDown(UINT nFlags, CPoint point)
{
     if (m_Display == Fonts)
          m_Display = Pens;
     else if (m_Display == Pens)
          m_Display = Brushes;
     else
          m_Display = Fonts;

     Invalidate(TRUE);

    CView::OnLButtonDown(nFlags, point);
}

void CPaint1View::Nike(CDC* pDC, int nCount)
{
}
